diff --git a/include/gammu-unicode.h b/include/gammu-unicode.h
index 98dabb2c16..d6dd88ca79 100644
--- a/include/gammu-unicode.h
+++ b/include/gammu-unicode.h
@@ -92,8 +92,7 @@ void DecodeUTF8QuotedPrintable(unsigned char *dest, const char *src,
  *
  * \ingroup Unicode
  */
-int EncodeWithUTF8Alphabet(unsigned char mychar1, unsigned char mychar2,
-			   char *ret);
+int EncodeWithUTF8Alphabet(unsigned long src, char *ret);
 /**
  * Decodes string from UTF-8.
  *
diff --git a/libgammu/misc/coding/coding.c b/libgammu/misc/coding/coding.c
index 2b0f926531..a097c56708 100644
--- a/libgammu/misc/coding/coding.c
+++ b/libgammu/misc/coding/coding.c
@@ -1463,12 +1463,10 @@ void StringToDouble(char *text, double *d)
 }
 
 /* When char can be converted, convert it from Unicode to UTF8 */
-int EncodeWithUTF8Alphabet(unsigned char mychar1, unsigned char mychar2, char *ret)
+int EncodeWithUTF8Alphabet(unsigned long src, char *ret)
 {
-	unsigned long src = mychar1 * 256 + mychar2;
-
 	if (src < 0x80) {
-		ret[0] = mychar2;
+		ret[0] = src;
 		return 1;
 	} else if (src < 0x800) {
 		ret[0] = 192 + (src / 64);
@@ -1502,8 +1500,7 @@ int EncodeWithUTF8Alphabet(unsigned char mychar1, unsigned char mychar2, char *r
 		return 6;
 	}
 
-	/* Unicode 0000-007F -> UTF8 0xxxxxxx */
-	ret[0] = mychar2;
+	ret[0] = src;
 	return 1;
 }
 
@@ -1517,7 +1514,7 @@ gboolean EncodeUTF8QuotedPrintable(char *dest, const unsigned char *src)
 	len = UnicodeLength(src);
 
 	for (i = 0; i < len; i++) {
-		z = EncodeWithUTF8Alphabet(src[i * 2], src[i * 2 + 1], mychar);
+		z = EncodeWithUTF8Alphabet(src[i * 2] * 256 + src[i * 2 + 1], mychar);
 		if (z == 1 && mychar[0] < 32) {
 			/* Need quoted printable for chars < 32 */
 			sprintf(dest + j, "=%02X", mychar[0]);
@@ -1550,7 +1547,7 @@ gboolean EncodeUTF8(char *dest, const unsigned char *src)
 	len = (int)UnicodeLength(src);
 
 	for (i = 0; i < len; i++) {
-		z = EncodeWithUTF8Alphabet(src[i * 2], src[i * 2 + 1], mychar);
+		z = EncodeWithUTF8Alphabet(src[i * 2] * 256 + src[i * 2 + 1], mychar);
 		memcpy(dest + j, mychar, z);
 		j += z;
 		if (z > 1) {
@@ -1718,7 +1715,7 @@ void DecodeXMLUTF8(unsigned char *dest, const char *src, int len)
 			}
 			dbgprintf(NULL, "Unicode char 0x%04lx\n", c);
 			tmplen = strlen(tmp);
-			tmplen += EncodeWithUTF8Alphabet((c >> 8) & 0xff, c & 0xff, tmp + tmplen);
+			tmplen += EncodeWithUTF8Alphabet(c, tmp + tmplen);
 			tmp[tmplen] = 0;
 		} else if (strcmp(entity, "amp") == 0) {
 			strcat(tmp, "&");
diff --git a/libgammu/phone/nokia/dct3/n6110.c b/libgammu/phone/nokia/dct3/n6110.c
index 0379bc0821..43b985af49 100644
--- a/libgammu/phone/nokia/dct3/n6110.c
+++ b/libgammu/phone/nokia/dct3/n6110.c
@@ -2216,7 +2216,7 @@ static GSM_Error N6110_AddCalendarNote(GSM_StateMachine *s, GSM_CalendarEntry *N
                                         req[22]++;              /* one additional char */
                                         req[current++] = 0x01;  /* we use now subset 1 */
                                         for (i=0;i<((int)UnicodeLength(Note->Entries[Text].Text));i++) {
-						j = EncodeWithUTF8Alphabet(Note->Entries[Text].Text[i*2],Note->Entries[Text].Text[i*2+1],req+current);
+						j = EncodeWithUTF8Alphabet(Note->Entries[Text].Text[i*2]*256+Note->Entries[Text].Text[i*2+1],req+current);
 						if (j > 1) {
                                                         req[23]= 0x03; /* use subset 3         */
                                                         req[22]+=j-1;  /* few additional chars */
